# This file is part of FatxFast.
#
#    FatxFast is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    FatxFast is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with FatxFast.  If not, see <http://www.gnu.org/licenses/>.

# Versioning based on: 
# http://en.wikipedia.org/wiki/Versioning#Designating_development_stage
__author__ = "dryatu (c) 2013"
__version__ = "1.1.1"

class FpsTimer(object):
    
    def __init__(self, fps, roughness=10, **kwargs):
        self._frames_to_store = roughness
        self._frame_times = [0]*roughness
        self.fps = fps
        self.framecount = 0

    def update(self, dt):
        frame_time_index = self.framecount%self._frames_to_store
        self._frame_times[frame_time_index] = dt
        self.framecount += 1
        if self.framecount < self._frames_to_store:
            count = self.framecount
        else:
            count = self._frames_to_store
        fps = 0
        for frame_index in xrange(count):
            fps += self._frame_times[frame_index]
        fps /= count
        return 1000.0/fps
