
# This file is part of FatxFast.
#
#    FatxFast is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    FatxFast is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with FatxFast.  If not, see <http://www.gnu.org/licenses/>.

# Versioning based on: 
# http://en.wikipedia.org/wiki/Versioning#Designating_development_stage
__author__ = "dryatu (c) 2013"
__version__ = "1.1.1"


from FatxFast.objects.character import Character
import pygame
from FatxFast.constants import *

class Player(Character):
    
    def __init__(self, gamescene, **kwargs):
        super(Player, self).__init__(gamescene, **kwargs)
        self.points = 0
        self.maps_left = 0
        self.walkspeed = self.maxspeed/10
        self.walk = False
        self.warp_cooldown = False
    
    def _trigger_events(self):
        collisions = pygame.sprite.spritecollide(self._collision_sprite, 
            self.gamescene.tilemap.world, False)
        if collisions:
            for col in collisions:
                if col.entity_id in TRIGGER_RANGE:
                    position_changed = col.process(self)
                    if col.entity_id == COFFEE_ID:
                        col.kill()
                    elif col.entity_id == END_ID:
                        self.gamescene.mode.level_up(self)
                    if position_changed:
                        return True

    def _move_by_speed(self, dt):
        if self.walk and self.speedvector.length():
            self.speedvector.scale_to_length(self.walkspeed)
        super(Player, self)._move_by_speed(dt)
